
   /*
      "Java 8 In Action", page 168
   */
   if (task is small enough or no longer divisible)
   {
      compute task sequentially
   }
   else
   {
      split task in two (or more) subtasks
      call this method recursively (possibly further splitting each subtask)
      wait for the completion of all subtasks
      combine the results from all subtasks
   }




   /*
      http://www.ibm.com/developerworks/java/library/j-jtp11137/index.html
   */
   Result solve(Problem problem)
   {
      if (problem.size < SEQUENTIAL_THRESHOLD)
      {
         return solveSequentially(problem);
      {
      else
      {
         Result left, right;
         INVOKE-IN-PARALLEL
         {
             left = solve(extractLeftHalf(problem));
            right = solve(extractRightHalf(problem));
         }
         return combine(left, right);
      }
   }